import java.util.*;

public class boardgame extends Legespiel {
	public static boolean validPosition( int column, int row ) {
		if( 1 <= column && column <= 8 && 1 <= row && row <= 8 ) {
			return true;
		} else {
			return false;
		}
	}
	
	public static void setField( int[][] grid, int column, int row, int type ) {
		grid[ column - 1 ][ row - 1 ] = type;
	}
	
	public static int getField( int[][] grid, int column, int row ) {
		if( validPosition( column, row ) ) {
			return grid[ column - 1 ][ row - 1 ];
		} else {
			return 0;
		}
	}
	
	public static int[] getClickedField() {
		int[] click = getSpielerZug();
		return new int[] { click[0] + 1, click[1] + 1 };
	}
	
	public static boolean validDropField( int[][] grid, int column, int row ) {
		if( getField( grid, column, row ) != 0 ) {
			return false;
		}
		// check surrounding fields
		if( getField( grid, column - 1, row + 1 ) != 0 || getField( grid, column, row + 1 ) != 0 || getField( grid, column + 1, row + 1) != 0 ||
			getField( grid, column - 1, row ) != 0 || getField( grid, column + 1, row ) != 0 ||
			getField( grid, column - 1, row - 1 ) != 0 || getField( grid, column, row - 1 ) != 0 || getField( grid, column + 1, row - 1 ) != 0 ) {
			return true;
		} else {
			return false;
		}
	}

	public static boolean switchDirectionFields_r( int[][] grid, int column, int row, int targetType, int[] direction ) {
		// find an item of the same type in the specified direction
		column += direction[0];
		row += direction[1];
		int fieldType = getField( grid, column, row );
		if( fieldType == 0 ) {
			return false;
		} else if( fieldType == targetType ) {
			return true;
		} else if( switchDirectionFields_r( grid, column, row, targetType, direction ) ) {
			// switch the type
			setField( grid, column, row, -fieldType );
			return true;
		} else {
			return false;
		}
	}
	
	public static void switchFields( int[][] grid, int column, int row ) {
		int type = getField( grid, column, row );
		int directions[][] = { {-1,1}, {0,1}, {1,1}, {-1,0}, {1,0}, {-1,-1}, {0,-1}, {1,-1} };
		for( int[] direction : directions ) {
			switchDirectionFields_r( grid, column, row, type, direction );
		}
	}
	
	public static int[][] cloneGrid( int[][] grid ) {
		int[][] clone = new int[ 8 ][ 8 ];
		for( int i = 0 ; i < 8 ; i++ ) {
			for( int j = 0 ; j < 8 ; j++ ) {
				clone[ i ][ j ] = grid[ i ][ j ];
			}
		}
		return clone;
	}
	
	public static int getComputerFieldCount( int[][] grid ) {
		int count = 0;
		
		for( int row = 1 ; row <= 8 ; row++ ) {
			for( int column = 1 ; column <= 8 ; column++ ) {
				if( getField( grid, column, row ) == -1 ) {
					count++;
				}
			}
		}
		
		return count;
	}
	
	public static int[] getComputerTurn( int[][] grid ) {
		// brute-force ok but I dont want to spend more time on the code :-/
		int bestColumn = 0, bestRow = 0;
		int bestDropCount = 0;
			
		for( int row = 1 ; row <= 8 ; row++ ) {
			for( int column = 1 ; column <= 8 ; column++ ) {
				if( !validDropField( grid, column, row ) ) {
					continue;
				}
				
				int[][] dummyGrid = cloneGrid( grid );
				// lets hypothetically drop the item here
				setField( dummyGrid, column, row, -1 );
				// switch the fields
				switchFields( dummyGrid, column, row );
				// count computer fields
				int dummyCount = getComputerFieldCount( dummyGrid );
				
				if( dummyCount > bestDropCount ) {
					bestDropCount = dummyCount;
					bestColumn = column;
					bestRow = row;
				}
			}
		}
		return new int[] { bestColumn, bestRow };
	}
	
	public static void main( String args[] ) {
		int[][] grid = new int[8][8];
		setField( grid, 4, 4, 1 );
		setField( grid, 5, 4, -1 );
		setField( grid, 4, 5, -1 );
		setField( grid, 5, 5, 1 );
		
		initLegespiel( grid );
		
		// 1 player, -1 computer (DONT CHANGE)
		int currentPlayer = 1;
		// 4 fields are placed, so only 60 are left
		int remainingFields = 8 * 8 - 4;
		while( remainingFields > 0 ) {
			int[] fieldPosition;
			if( currentPlayer == 1 ) {
				fieldPosition = getClickedField();
			} else {
				try {
				    Thread.sleep(500);
				}catch(InterruptedException ie){
				}
				fieldPosition = getComputerTurn( grid );
			}
			int column = fieldPosition[0], row = fieldPosition[1];
			if( !validDropField( grid, column, row ) ) {
				continue;
			}
			
			setField( grid, column, row, currentPlayer );
			switchFields( grid, column, row );
				
			updateLegespiel( grid );
			
			currentPlayer = -currentPlayer;
			remainingFields--;
		}
	}
}
